#!/usr/bin/python
from network import WLAN
from socket import socket
import socket
import struct
from network import LoRa
import machine
import utime
from machine import RTC
import os
import urequests
from mqtt import MQTTClient
import pycom, time

from machine import UART
uart = UART(1, baudrate=9600)

def sub_cb(topic, msg):
   print(msg)

wlan = WLAN(mode=WLAN.STA)
wlan.connect("mobile_hotspot_name", auth=(WLAN.WPA2, "mobile_hotspot_password"), timeout=5000)

while not wlan.isconnected():
    machine.idle()
print("Connected to Wifi\n")

client = MQTTClient("fipy", "Server Name/ IP", port=1883)
client.set_callback(sub_cb)
client.connect()
client.subscribe(topic="sensors/#")

_LORA_PKG_FORMAT = "!BB%ds"
_LORA_PKG_ACK_FORMAT = "BBB"
lora = LoRa(mode=LoRa.LORA, rx_iq=True, region=LoRa.AS923)
lora_sock = socket.socket(socket.AF_LORA, socket.SOCK_RAW)
lora_sock.setblocking(False)

while (True):
    recv_pkg = lora_sock.recv(512)
    if (len(recv_pkg) > 2):
        recv_pkg_len = recv_pkg[1]
        device_id, pkg_len, msg = struct.unpack(_LORA_PKG_FORMAT % recv_pkg_len, recv_pkg)
        print('getting messages')
        print('Device: %d - Pkg:  %s' % (device_id, msg))
        client.publish(topic="sensors/", msg=msg)
        uart.write(msg)
        #time.sleep(1)
        print("Data sent from FiPy to Rpi")
        print('got messages')
        ack_pkg = struct.pack(_LORA_PKG_ACK_FORMAT, device_id, 1, 200)
        lora_sock.send(ack_pkg)

